/**
*  Copyright (C) 2000 - DivXNetworks
**/
// codec.h //

#ifndef _CODEC_H_
#define _CODEC_H_


struct STATE_DATA

{
	long bitrate;	// the bitrate of the target encoded stream
	long rc_period; // the intended keyframe_rate for encoding
	long rc_reaction_period;
	long rc_reaction_ratio;
	long max_key_interval;
	int max_quantizer;
	int min_quantizer;
	int search_range; // the forward search range for motion estimation

	int quality;



	STATE_DATA()

		:

		rc_period (2000),

		rc_reaction_period (10),

		rc_reaction_ratio (20),

		max_key_interval (300),

		bitrate (780000),

		search_range (128),

		max_quantizer (12),

		min_quantizer (2),

		quality (5)

		{}
};


class codec {

private:
	float framerate;

#ifdef _ENCORE2_

	void* m_hEnc;

#else

	unsigned long m_hEnc;

#endif

	//operations
public:
	codec();
	~codec();
	long about(LPARAM lParam1, LPARAM lParam2);
	long config(LPARAM lParam1, LPARAM lParam2);
	long getInfo(LPARAM lParam1, LPARAM lParam2);
	long encGetFormat(LPARAM lParam1, LPARAM lParam2);
	long encGetSize(LPARAM lParam1, LPARAM lParam2);
	long encQuery(LPARAM lParam1, LPARAM lParam2);
	long encFramesInfo(LPARAM lParam1, LPARAM lParam2);
	long encBegin(LPARAM lParam1, LPARAM lParam2);
	long encEncode(LPARAM lParam1, LPARAM lParam2);
	long encEnd(LPARAM lParam1, LPARAM lParam2);
	long decGetFormat(LPARAM lParam1, LPARAM lParam2);
	long decQuery(LPARAM lParam1, LPARAM lParam2);
	long decBegin(LPARAM lParam1, LPARAM lParam2);
	long decDecode(LPARAM lParam1, LPARAM lParam2);
	long decEnd(LPARAM lParam1, LPARAM lParam2);

	// decoder set
	long decSetPostProcessing(LPARAM lParam1, LPARAM lParam2);

	STATE_DATA m_stSTATE_DATA;

private:

	bool m_bDecompressBeginDone;

	int getImageType(BITMAPV4HEADER *bmpinfohdr);
	void convertImage(void *imageIn, void *imageOut, long type, long x_dim, long y_dim);
	void InitLookupTable();
	int convertRGB (void *bmp, void *yuv, long type, long x_dim, long y_dim);
	int convertYUV422 (void *yuv422, void *yuv, long type, long x_dim, long y_dim);
	int convertYUV420 (void *yuv420, void *yuv, long type, long x_dim, long y_dim);
};

#endif // _CODEC_H_

#include <vfw.h>

static const DWORD FOURCC_DIVX = mmioFOURCC('D','I','V','X');   // DivX format
static const DWORD FOURCC_UYVY = mmioFOURCC('U','Y','V','Y');   // uncompressed UYVY
static const DWORD FOURCC_YUY2 = mmioFOURCC('Y','U','Y','2');   // uncompressed YUY2
static const DWORD FOURCC_YUYV = mmioFOURCC('Y','U','Y','V');   // uncompressed YUYV - same as YUY2
static const DWORD FOURCC_V422 = mmioFOURCC('V','4','2','2');   // uncompressed V422 - same as YUY2
static const DWORD FOURCC_YVYU = mmioFOURCC('Y','V','Y','U');   // uncompressed YVYU
static const DWORD FOURCC_YV12 = mmioFOURCC('Y','V','1','2');   // uncompressed YV12 - MPEG format of choice
static const DWORD FOURCC_I420 = mmioFOURCC('I','4','2','0');   // uncompressed I420
static const DWORD FOURCC_IYUV = mmioFOURCC('I','Y','U','V');   // uncompressed IYUV - same as I420

typedef struct _FOURCC_LOOKUP_STRUCT
{
    DWORD nFourCC;
    unsigned int nInternalCode;

} FOURCC_LOOKUP;

extern FOURCC_LOOKUP dec_lookup_table[]; 
/*
extern long rc_period, bitrate;
extern long rc_reaction_period, rc_reaction_ratio;
extern long max_key_interval;
extern int search_range;
extern int max_quantizer;
extern int min_quantizer;
extern int quality;

*/

